package org.zeroturnaround.javarebel.integration.jasper;

import org.zeroturnaround.javarebel.ClassResourceSource;
import org.zeroturnaround.javarebel.IntegrationFactory;
import org.zeroturnaround.javarebel.Plugin;

/**
 * JRebel plugin for Jasper.
 * <p>
 * JETTY 6.1 (Tested on 6.1.12)
 * TOMCAT 5.5 (Tested on 5.5.27)
 *  
 * @author Rein Raudjärv
 * 
 * TODO what is JspCompilationContextCBP for?
 */
public class JasperPlugin implements Plugin {
  public void preinit() {
    ClassLoader cl = getClass().getClassLoader();

    IntegrationFactory.getInstance().addIntegrationProcessor(
        cl,
        "org.apache.jasper.compiler.Compiler", 
        new CompilerCBP());
    IntegrationFactory.getInstance().addIntegrationProcessor(
        cl,
        "org.apache.jasper.servlet.JspServlet", 
        new JspServletCBP());
  }

  public boolean checkDependencies(ClassLoader cl, ClassResourceSource crs) {
    return crs.getClassResource("org.apache.jasper.servlet.JspServlet") != null;
  }
 
  public String getId() {
    return "jasper_plugin";
  }
  
  public String getName() {
    return null;
  }
  
  public String getDescription() {
    return null;
  }

  public String getAuthor() {
    return null;
  }

  public String getWebsite() {
    return null;
  }  
}
