package org.zeroturnaround.javarebel.integration.jasper;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtNewMethod;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>org.apache.jasper.JspCompilationContext</code>
 * by adding it additional interface.
 * 
 * @author Rein Raudjärv
 */
public class JspCompilationContextCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    ctClass.addInterface(cp.get(JspCompilationContextExtra.class.getName()));
    
    ctClass.addMethod(CtNewMethod.make(
        "public Object __getRuntimeContext() { return rctxt; }", ctClass));
  }

}
