package org.zeroturnaround.javarebel.integration.jasper;

import java.io.FileNotFoundException;

/**
 * Exception that is used internally in case a JSP page was removed. 
 * 
 * @author Rein Raudjärv
 */
public class JspRemovedException extends FileNotFoundException {

  private static final long serialVersionUID = 1L;
  
  /**
   * Constructs a <code>JspRemovedException</code> with
   * <code>null</code> as its error detail message.
   */
  public JspRemovedException() {
  super();
  }

  /**
   * Constructs a <code>JspRemovedException</code> with the
   * specified detail message. The string <code>s</code> can be
   * retrieved later by the
   * <code>{@link java.lang.Throwable#getMessage}</code>
   * method of class <code>java.lang.Throwable</code>.
   *
   * @param   s   the detail message.
   */
  public JspRemovedException(String s) {
  super(s);
  }  

}
