package org.zeroturnaround.javarebel.integration.jasper;


import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.CtNewMethod;
import org.zeroturnaround.bundled.javassist.NotFoundException;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

/**
 * Transforms <code>org.apache.jasper.servlet.JspServlet</code>.
 * 
 * @author Rein Raudjärv
 * 
 * @see CompilerCBP
 */
public class JspServletCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    /*
     * If JspRemovedException is caught serviceJspFile method will be called once again
     * to send a 404 error to the client
     */
    
    try {
      CtMethod origMethod = ctClass.getDeclaredMethod("serviceJspFile");
      CtMethod copyMethod = CtNewMethod.copy(origMethod, "_serviceJspFile", ctClass, null);
      ctClass.addMethod(copyMethod);
      
      origMethod.setBody(
          "{" +
          "  try {" +
          "    _serviceJspFile($$);" +
          "  } catch (" + JspRemovedException.class.getName() + " e) {" +
          "    _serviceJspFile($$);" +
          "  } catch (org.apache.jasper.JasperException e) {" +
          "    Throwable t = e.getRootCause();" +
          "    if (t instanceof " + JspRemovedException.class.getName() + ") {" +
          "      _serviceJspFile($$);" +
          "    } else {" +
          "      throw e;" +
          "    }" +
          "  }" +
          "}");
    } catch (NotFoundException e) {
    }
  }
}
